/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.gui.widgets.utils.drag2D;

import java.awt.BasicStroke;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import javax.swing.JFrame;
import javax.swing.JPanel;
import org.apache.log4j.Logger;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author szpak
 */
public class DirectionalDragTestFrame extends javax.swing.JFrame
{
    private static final Logger LOGGER = Logger.getLogger(DirectionalDragTestFrame.class);

    private JPanel[] panels;

    /**
     * Creates new form Dragger2DTestFrame
     */
    public DirectionalDragTestFrame()
    {
        initComponents();

        panels = new JPanel[]{new DragPerpendicularExample(), new DragObliqueExample(), new MovePerpendicularExample(), new MoveObliqueExample()};
        for (JPanel jPanel : panels)
            exampleCardPanel.add(jPanel, jPanel.getClass().getName());
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        comboBox1 = new org.visnow.vn.gui.swingwrappers.ComboBox();
        exampleCardPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        comboBox1.setListData(new String[] {"Drag perpendicular", "Drag oblique", "Move perpendicular", "Move oblique"});
        comboBox1.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                comboBox1UserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        getContentPane().add(comboBox1, java.awt.BorderLayout.NORTH);

        exampleCardPanel.setLayout(new java.awt.CardLayout());
        getContentPane().add(exampleCardPanel, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void comboBox1UserChangeAction(java.util.EventObject evt)//GEN-FIRST:event_comboBox1UserChangeAction
    {//GEN-HEADEREND:event_comboBox1UserChangeAction
        ((CardLayout) exampleCardPanel.getLayout()).show(exampleCardPanel, panels[comboBox1.getSelectedIndex()].getClass().getName());
        repaint();
    }//GEN-LAST:event_comboBox1UserChangeAction

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        VisNow.initLogging(true);


        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                JFrame jFrame = new DirectionalDragTestFrame();
                jFrame.setLocation(400, 300);
                jFrame.setSize(400, 300);
                jFrame.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.swingwrappers.ComboBox comboBox1;
    private javax.swing.JPanel exampleCardPanel;
    // End of variables declaration//GEN-END:variables

    private static class DragPerpendicularExample extends JPanel
    {
        final Line2D.Double dragLine = new Line2D.Double(140, 80, 280, 120);
        final Point2D.Double dragPoint = new Point2D.Double(140, 80);

        public DragPerpendicularExample()
        {
            setBackground(new Color(0xeeeeee));

            MouseAdapter mouseAdapter = new MouseAdapter()
            {
                DirectionalDrag directionalDrag;
                Point2D.Double startPoint;
                double dragAxisX;
                double dragAxisY;

                @Override
                public void mouseDragged(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    double drag = directionalDrag.calculateDrag(e.getX(), h_1 - e.getY());
                    LOGGER.debug("drag = " + drag);
                    dragPoint.x = startPoint.x + drag * dragAxisX;
                    dragPoint.y = startPoint.y + drag * dragAxisY;
                    repaint();
                }

                @Override
                public void mousePressed(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    dragAxisX = dragLine.x2 - dragLine.x1;
                    dragAxisY = dragLine.y2 - dragLine.y1;
                    double length = Math.sqrt(dragAxisX * dragAxisX + dragAxisY * dragAxisY);
                    dragAxisX /= length;
                    dragAxisY /= length;

                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    directionalDrag = new DirectionalDrag(e.getX(), h_1 - e.getY(), dragAxisX, dragAxisY);
                    startPoint = (Point2D.Double) (dragPoint.clone());
                }
            };

            addMouseListener(mouseAdapter);
            addMouseMotionListener(mouseAdapter);
        }

        @Override
        public void paint(Graphics g)
        {
            super.paint(g);
            int h_1 = getHeight() - 1;
            Graphics2D g2d = (Graphics2D) g;
            g2d.setStroke(new BasicStroke(1));
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1, (int) dragLine.x2, h_1 - (int) dragLine.y2);
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1,
                       (int) dragLine.x1 + (int) dragLine.y1 - (int) dragLine.y2,
                       h_1 - (int) dragLine.y1 + (int) dragLine.x1 - (int) dragLine.x2);
            g2d.setStroke(new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1, new float[]{1}, 0));
            g.drawLine((int) dragPoint.x, h_1 - (int) dragPoint.y, (int) dragPoint.x, h_1 - (int) dragPoint.y + 1);
        }
    }

    private static class DragObliqueExample extends JPanel
    {
        final Line2D.Double dragLine = new Line2D.Double(140, 80, 280, 120);
        final Point2D.Double dragPoint = new Point2D.Double(140, 80);

        public DragObliqueExample()
        {
            setBackground(new Color(0xf3f3f3));

            MouseAdapter mouseAdapter = new MouseAdapter()
            {
                DirectionalDrag directionalDrag;
                Point2D.Double startPoint;
                double dragAxisX;
                double dragAxisY;

                @Override
                public void mouseDragged(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    double drag = directionalDrag.calculateDrag(e.getX(), h_1 - e.getY());
                    LOGGER.debug("drag = " + drag);
                    dragPoint.x = startPoint.x + drag * dragAxisX;
                    dragPoint.y = startPoint.y + drag * dragAxisY;
                    repaint();
                }

                @Override
                public void mousePressed(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    dragAxisX = dragLine.x2 - dragLine.x1;
                    dragAxisY = dragLine.y2 - dragLine.y1;
                    double length = Math.sqrt(dragAxisX * dragAxisX + dragAxisY * dragAxisY);
                    dragAxisX /= length;
                    dragAxisY /= length;

                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    directionalDrag = new DirectionalDrag(e.getX(), h_1 - e.getY(), dragAxisX, dragAxisY, 0, 1);
                    startPoint = (Point2D.Double) (dragPoint.clone());
                }
            };

            addMouseListener(mouseAdapter);
            addMouseMotionListener(mouseAdapter);
        }

        @Override
        public void paint(Graphics g)
        {
            super.paint(g);
            int h_1 = getHeight() - 1;
            Graphics2D g2d = (Graphics2D) g;
            g2d.setStroke(new BasicStroke(1));
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1, (int) dragLine.x2, h_1 - (int) dragLine.y2);
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1,
                       (int) dragLine.x1, h_1 - (int) dragLine.y1 - 50);
            g2d.setStroke(new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1, new float[]{1}, 0));
            g.drawLine((int) dragPoint.x, h_1 - (int) dragPoint.y, (int) dragPoint.x, h_1 - (int) dragPoint.y + 1);
        }
    }

    private static class MovePerpendicularExample extends JPanel
    {
        final Line2D.Double dragLine = new Line2D.Double(140, 80, 280, 120);
        final Point2D.Double dragPoint = new Point2D.Double(140, 80);

        public MovePerpendicularExample()
        {
            setBackground(new Color(0xeeeeee));

            MouseAdapter mouseAdapter = new MouseAdapter()
            {
                DirectionalDrag directionalDoubleDrag;
                Point2D.Double startPoint;
                double dragAxis1X;
                double dragAxis1Y;

                @Override
                public void mouseDragged(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    double[] drag = directionalDoubleDrag.calculateDoubleDrag(e.getX(), h_1 - e.getY());
                    dragPoint.x = startPoint.x + drag[0] * dragAxis1X - drag[1] * dragAxis1Y;
                    dragPoint.y = startPoint.y + drag[0] * dragAxis1Y + drag[1] * dragAxis1X;
                    repaint();
                }

                @Override
                public void mousePressed(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    dragAxis1X = dragLine.x2 - dragLine.x1;
                    dragAxis1Y = dragLine.y2 - dragLine.y1;
                    double length1 = Math.sqrt(dragAxis1X * dragAxis1X + dragAxis1Y * dragAxis1Y);
                    dragAxis1X /= length1;
                    dragAxis1Y /= length1;

                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    directionalDoubleDrag = new DirectionalDrag(e.getX(), h_1 - e.getY(), dragAxis1X, dragAxis1Y);
                    startPoint = (Point2D.Double) (dragPoint.clone());
                }
            };

            addMouseListener(mouseAdapter);
            addMouseMotionListener(mouseAdapter);
        }

        @Override
        public void paint(Graphics g)
        {
            super.paint(g);
            int h_1 = getHeight() - 1;
            Graphics2D g2d = (Graphics2D) g;
            g2d.setStroke(new BasicStroke(1));
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1, (int) dragLine.x2, h_1 - (int) dragLine.y2);
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1,
                       (int) dragLine.x1 + (int) dragLine.y1 - (int) dragLine.y2,
                       h_1 - (int) dragLine.y1 + (int) dragLine.x1 - (int) dragLine.x2);
            g2d.setStroke(new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1, new float[]{1}, 0));
            g.drawLine((int) dragPoint.x, h_1 - (int) dragPoint.y, (int) dragPoint.x, h_1 - (int) dragPoint.y + 1);
        }
    }

    private static class MoveObliqueExample extends JPanel
    {
        final Line2D.Double dragLine = new Line2D.Double(140, 80, 280, 120);
        final Point2D.Double dragPoint = new Point2D.Double(140, 80);

        public MoveObliqueExample()
        {
            setBackground(new Color(0xf3f3f3));

            MouseAdapter mouseAdapter = new MouseAdapter()
            {
                DirectionalDrag directionalDoubleDrag;
                Point2D.Double startPoint;
                double dragAxis1X;
                double dragAxis1Y;

                @Override
                public void mouseDragged(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    double[] drag = directionalDoubleDrag.calculateDoubleDrag(e.getX(), h_1 - e.getY());
                    dragPoint.x = startPoint.x + drag[0] * dragAxis1X;
                    dragPoint.y = startPoint.y + drag[0] * dragAxis1Y + drag[1] * 1;
                    repaint();
                }

                @Override
                public void mousePressed(MouseEvent e)
                {
                    int h_1 = getHeight() - 1;
                    dragAxis1X = dragLine.x2 - dragLine.x1;
                    dragAxis1Y = dragLine.y2 - dragLine.y1;
                    double length1 = Math.sqrt(dragAxis1X * dragAxis1X + dragAxis1Y * dragAxis1Y);
                    dragAxis1X /= length1;
                    dragAxis1Y /= length1;

                    LOGGER.debug(e.getX() + " " + (h_1 - e.getY()));

                    directionalDoubleDrag = new DirectionalDrag(e.getX(), h_1 - e.getY(), dragAxis1X, dragAxis1Y, 0, 1);
                    startPoint = (Point2D.Double) (dragPoint.clone());
                }
            };

            addMouseListener(mouseAdapter);
            addMouseMotionListener(mouseAdapter);
        }

        @Override
        public void paint(Graphics g)
        {
            super.paint(g);
            int h_1 = getHeight() - 1;
            Graphics2D g2d = (Graphics2D) g;
            g2d.setStroke(new BasicStroke(1));
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1, (int) dragLine.x2, h_1 - (int) dragLine.y2);
            g.drawLine((int) dragLine.x1, h_1 - (int) dragLine.y1,
                       (int) dragLine.x1, h_1 - (int) dragLine.y1 - 50);
            g2d.setStroke(new BasicStroke(4, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 1, new float[]{1}, 0));
            g.drawLine((int) dragPoint.x, h_1 - (int) dragPoint.y, (int) dragPoint.x, h_1 - (int) dragPoint.y + 1);
        }
    }

}
